/*
 * 
 * ================================================================================================== *
 * 类名：CLASS_MSN_MESSAGE * 功能：提供类似MSN消息框 * 示例：
 * ---------------------------------------------------------------------------------------------------
 * 消息构造
 */
function CLASS_MSN_MESSAGE(id, width, height, caption, title, name, sendperson,
		sendtime, furl, target, fProcess, fActivity, fExecutorFID, maction) {
	this.id = id;
	this.title = title;
	this.caption = caption;
	this.message = name;
	this.sendperson = sendperson;
	this.sendtime = sendtime;
	this.furl = furl;
	this.target = target;
	this.fProcess = fProcess;
	this.fActivity = fActivity;
	this.fExecutorFID = fExecutorFID;
	this.maction = maction;
	this.width = width ? width : 200;
	this.height = height ? height : 180;
	this.timeout = 150;
	this.speed = 20;
	this.step = 1;
	this.right = screen.width - 1;
	this.bottom = screen.height;
	this.left = this.right - this.width;
	this.top = this.bottom - this.height;
	this.timer = 0;
	this.pause = false;
	this.close = true;
	this.autoHide = false;
}

/*
 * 隐藏消息方法
 */
CLASS_MSN_MESSAGE.prototype.hide = function() {
	if (this.onunload()) {
		var offset = this.height > this.bottom - this.top ? this.height
				: this.bottom - this.top;
		var me = this;
		if (this.timer > 0) {
			window.clearInterval(me.timer);
		}
		var fun = function() {
			if (me.pause == false || me.close) {
				var x = me.left;
				var y = 0;
				var width = me.width;
				var height = 0;
				if (me.offset > 0) {
					height = me.offset;
				}

				y = me.bottom - height;

				if (y >= me.bottom) {
					window.clearInterval(me.timer);
					me.Pop.hide();
				} else {
					me.offset = me.offset - me.step;
				}
				me.Pop.show(x, y, width, height);
			}
		};
		this.timer = window.setInterval(fun, this.speed);
	}
};

/*
 * 消息卸载事件，可以重写
 */
CLASS_MSN_MESSAGE.prototype.onunload = function() {
	return true;
};
/*
 * 消息命令事件，要实现自己的连接，请重写它
 * 
 */
CLASS_MSN_MESSAGE.prototype.oncommand = function() {
	// this.close = true;
	// window.open(this.link);
	/*
	 * var url = $.jpolite.ClientInfo.hostPath + "/" + (this.url ? this.url :
	 * "OA/abroadApply/process/abroadApply/summarizeActivity.w") + "?task=" +
	 * (this.target ? this.target : "EEE63A9C9DFC4FD1833CE246DB0BE322") +
	 * "&activity-pattern=do" + "&bsessionid=" + $.jpolite.ClientInfo.businessId +
	 * "&language=" + $.jpolite.ClientInfo.locale + "&executor=" +
	 * justep.Portal.getUserInfo().personId;
	 * justep.Portal.Tab.open(this.message, url);
	 */
	openTask(this.fProcess, this.fActivity, this.message, this.furl,
			this.target, this.fExecutorFID, this.maction);
	var sql =  "update SA_TASK set sESField01 = 'true' where sID = '"+this.target+"'";
	var model_cq = "/system/data";
	chqComUtils.sqlUpdateAction(sql,model_cq);
	this.hide();
};

/*
 * 消息显示方法
 */
CLASS_MSN_MESSAGE.prototype.show = function() {
	var oPopup = window.createPopup(); // IE5.5+

	this.Pop = oPopup;

	var w = this.width;
	var h = this.height;

	var str = "<DIV style='BORDER-RIGHT: #455690 1px solid; BORDER-TOP: #a6b4cf 1px solid; Z-INDEX: 99999; LEFT: 0px; BORDER-LEFT: #a6b4cf 1px solid; WIDTH: "
			+ w
			+ "px; BORDER-BOTTOM: #455690 1px solid; POSITION: absolute; TOP: 0px; HEIGHT: "
			+ h + "px; BACKGROUND-COLOR: #c9d3f3'>";
	str += "<TABLE style='BORDER-TOP: #ffffff 1px solid; BORDER-LEFT: #ffffff 1px solid' cellSpacing=0 cellPadding=0 width='100%' bgColor=#cfdef4 border=0>";
	str += "<TR>";
	str += "<TD style='FONT-SIZE: 12px;COLOR: #0f2c8c' width=30 height=24></TD>";
	str += "<TD style='PADDING-LEFT: 4px; FONT-WEIGHT: normal; FONT-SIZE: 12px; COLOR: #1f336b; PADDING-TOP: 4px' vAlign=center width='100%'>"
			+ this.caption + "</TD>";
	str += "<TD style='PADDING-RIGHT: 2px; PADDING-TOP: 2px' vAlign=center align=right width=19>";
	str += "<SPAN title=关闭 style='FONT-WEIGHT: bold; FONT-SIZE: 12px; CURSOR: hand; COLOR: red; MARGIN-RIGHT: 4px' id='btSysClose' >×</SPAN></TD>";
	str += "</TR>";
	str += "<TR>";
	str += "<TD style='PADDING-RIGHT: 1px;PADDING-BOTTOM: 1px' colSpan=3 height="
			+ (h - 28) + ">";
	str += "<DIV style='BORDER-RIGHT: #b9c9ef 1px solid; PADDING-RIGHT: 8px; BORDER-TOP: #728eb8 1px solid; PADDING-LEFT: 8px; FONT-SIZE: 12px; PADDING-BOTTOM: 8px; BORDER-LEFT: #728eb8 1px solid; WIDTH: 100%; COLOR: #1f336b; PADDING-TOP: 8px; BORDER-BOTTOM: #b9c9ef 1px solid; HEIGHT: 100%'>"
			+ this.title + "<BR><BR>";
	str += "<DIV style='WORD-BREAK: break-all' align=left><table style='FONT-SIZE: 12px;' border='0' width='100%'><tr><td colspan='3'>"
			+ "<A href='javaScript:void(0)' hidefocus=true id='btCommand'><FONT color=#ff0000>&nbsp;"
			+ this.message
			+ "&nbsp;&nbsp;"
			+ this.sendperson
			+ "&nbsp;&nbsp;&nbsp;"
			+ this.sendtime
			+ "</FONT></A></td></tr></table></FONT><br/><br/><br/><br/><div align='right'><FONT color='#0066FF'>X5协同运营管理系统</FONT></div></DIV>";
	str += "</DIV>";
	str += "</TD>";
	str += "</TR>";
	str += "</TABLE>";
	str += "</DIV>";

	oPopup.document.body.innerHTML = str;

	this.offset = 0;
	var me = this;
	oPopup.document.body.onmouseover = function() {
		me.pause = true;
	};
	oPopup.document.body.onmouseout = function() {
		me.pause = false;
	};
	var fun = function() {
		var x = me.left;
		var y = 0;
		var width = me.width;
		var height = me.height;
		if (me.offset > me.height) {
			height = me.height;
		} else {
			height = me.offset;
		}
		y = me.bottom - me.offset;
		if (y <= me.top) {
			me.timeout--;
			if (me.timeout == 0) {
				window.clearInterval(me.timer);
				if (me.autoHide) {
					me.hide();
				}
			}
		} else {
			me.offset = me.offset + me.step;
		}
		me.Pop.show(x, y, width, height);
	};

	this.timer = window.setInterval(fun, this.speed);

	var btClose = oPopup.document.getElementById("btSysClose");

	btClose.onclick = function() {
		me.close = true;
		me.hide();
	};

	var btCommand = oPopup.document.getElementById("btCommand");
	btCommand.onclick = function() {
		me.oncommand();
	};

};
/*
 * 设置速度方法
 */
CLASS_MSN_MESSAGE.prototype.speed = function(s) {
	var t = 10;
	try {
		t = praseInt(s);
	} catch (e) {
	}
	this.speed = t;
};
/*
 * 设置步长方法
 */
CLASS_MSN_MESSAGE.prototype.step = function(s) {
	var t = 1;
	try {
		t = praseInt(s);
	} catch (e) {
	}
	this.step = t;
};

CLASS_MSN_MESSAGE.prototype.rect = function(left, right, top, bottom) {
	try {
		this.left = left != null ? left : this.right - this.width;
		this.right = right != null ? right : this.left + this.width;
		this.bottom = bottom != null ? (bottom > screen.height ? screen.height
				: bottom) : screen.height;
		this.top = top != null ? top : this.bottom - this.height;
	} catch (e) {
	}
};

var sendcout = 0;
function show_msn_message(name, creator, creattime, url, taskid, sProcess,
		sActivity, sExecutorFID, action) {
	if (sendcout == 0) {
		var MSG1 = new CLASS_MSN_MESSAGE(Math.round(Math.random() * 1000), 250,
				180, "任务提示：", "您有1个未处理的任务", name, creator, creattime, url,
				taskid, sProcess, sActivity, sExecutorFID, action);
		MSG1.rect(null, null, null, screen.height - 50);
		MSG1.speed = 10;
		MSG1.step = 5;
		// alert(MSG1.link);
		MSG1.show();
		sendcout++;
	} 
}

function timer_show_msn_message(name, creator, creattime, url, taskid,
		sProcess, sActivity, sExecutorFID, action) {
	var MSG1 = new CLASS_MSN_MESSAGE(Math.round(Math.random() * 1000), 250,
			180, "任务提示：", "您有1个未处理的任务", name, creator, creattime, url, taskid,
			sProcess, sActivity, sExecutorFID, action);
	MSG1.rect(null, null, null, screen.height - 50);
	MSG1.speed = 10;
	MSG1.step = 5;
	// alert(MSG1.link);
	MSG1.show();
	sendcout = 0;
}
/*
 * show_msn_message("技术部汇总-出国申请", "system", "2011-7-5 08:12:10",
 * "OA/abroadApply/process/abroadApply/summarizeActivity.w", false);
 */
